package main

import (
	"html/template"
	"os"
	"strings"
)

func main() {
	tplText := `hello golang {{ upper . }} {{ title . }}`
	funcs := template.FuncMap{
		"upper": strings.ToUpper,
		"title": func(str string) string {
			if len(str) == 0 {
				return ""
			} else if len(str) == 1 {
				return strings.ToUpper(str)
			}
			return strings.ToUpper(str[:1]) + str[1:]
		},
	}
	// 模板函数必须在解析模板前加载
	tpl := template.Must(template.New("tpl").Funcs(funcs).Parse(tplText))
	tpl.Execute(os.Stdout, "abcde")
}
